this.name 			= "pods";
this.author 		= "rustem, cag, Thargoid";
this.copyright 		= "2020 Creative Commons: attribution, non-commercial, sharealike.";
this.description 	= "Central script for storing all the resources (timers & sounds) and functions and all the pod scripts refer to it using a direct reference.";

this.logging = false; // false for release

this.npc_message = true; // for switch npc-message

(function () {
	"use strict";

	this.$direct_hit_sound = null; // store object ref for sound effects
	this.$warning_sound = null;

	this.$msgTimer = this.$msgTimerJam = this.$msgTimerExp = this.$msgTimerBrh = null; // store timer ref
	this.$hullBreachTimer = this.$removeCargoTimer = null;
	this.$eqpTimer = null;

	this.$message = this.$scooper = []; //"" / []; // WAIT: optimal work for worldScripts.pods?
	this.$msgJam = this.$msgExp = this.$msgBrh = [];
	this.$scrJam = this.$scrExp = this.$scrBrh = [];
	this.$equip = "";
	this.$drship = this.$drcargo = "";
	this.$deqlog = this.$drlog = null;

	// these declarations are not really necessary, unless you rely on their initial value
	// but it's a good way to document your code

	this.startUp = function () {
		var wp = worldScripts.pods;

		// initialize sound effects
		wp.$direct_hit_sound = new SoundSource();
		wp.$direct_hit_sound.loop = false;
		wp.$direct_hit_sound.sound = "[player-direct-hit]";

		wp.$warning_sound = new SoundSource();
		wp.$warning_sound.loop = false;
		wp.$warning_sound.sound = "[@warning]";

		//wp.$initialiseTimer();
		//wp.$hullBreachTimer = new Timer(wp, wp.$hullBreach,14,14) // default + delay / 10 + 4
		//wp.$hullBreachTimer.stop();
		//if (wp.logging) log(this.name, "setup hullBreach timer for worldScripts");
	}

	this.shipWillDockWithStation = this.shipEnteredWitchspace = function () {
		// stop timers
		var wp = worldScripts.pods;
		if (wp.$msgTimer && wp.$msgTimer.isRunning)
			wp.$msgTimer.stop();
		if (wp.$msgTimerJam && wp.$msgTimerJam.isRunning)
			wp.$msgTimerJam.stop();
		if (wp.$msgTimerExp && wp.$msgTimerExp.isRunning)
			wp.$msgTimerExp.stop();
		if (wp.$msgTimerBrh && wp.$msgTimerBrh.isRunning)
			wp.$msgTimerBrh.stop();
		if (wp.$hullBreachTimer && wp.$hullBreachTimer.isRunning)
			wp.$hullBreachTimer.stop();
		if (wp.$removeCargoTimer && wp.$removeCargoTimer.isRunning)
			wp.$removeCargoTimer.stop();
		if (wp.$eqpTimer && wp.$eqpTimer.isRunning)
			wp.$eqpTimer.stop();
		
		// used by player only
		if (wp.$direct_hit_sound.isPlaying)
			wp.$direct_hit_sound.stop();
		if (wp.$warning_sound.isPlaying)
			wp.$warning_sound.stop();

		// used by NPC-ship
		// var sc = this.ship.script; // scr ~ scooper
		// WAIT: clean up timers and etc.
		// delete sc.$msgTimerBrh;
		// delete sc.$hullBreachTimer;
		// sc.$msgBrh = sc.$scrBrh = [];
		// if (sc._delayedMsg_breachPod) { delete sc._delayedMsg_breachPod; }
	}

	//this.shipExitedWitchspace = function () {
	// WAIT: clearing message and scooper arrays

	//this.$message = this.$scooper = [];
	//this.$msgJam = this.$msgExp = this.$msgBrh = [];
	//this.$scrJam = this.$scrExp = this.$scrBrh = [];
	//this.$equip = "";	
	//this.$drship = this.$drcargo = "";
	//this.$deqlog = this.$drlog = null;
	//}

	this._delayedMsg = function (msg, t) {
		var wp = worldScripts.pods;
		if (msg) { // there is a message to output
			wp.$message.push(msg);	// WAIT: handle more than one message at a time //wp.$message = msg; // save msg for use in callback
			if (!wp.$msgTimer) { // 1st message ever, set-up timer
				// new Timer(this : Object, function : Function, delay : Number [, interval : Number]) : Timer
				wp.$msgTimer = new Timer(wp, wp._delayedMsg, t, t);
				if (wp.logging) log(this.name, "setup generic timer");
			} else {
				wp.$msgTimer.start();
				if (wp.logging) log(this.name, "start timer : generic");
			}
		} else { // timer calls itself, we have to write the message
			if (wp.logging) log(this.name, "stop timer : generic");
			player.consoleMessage(wp.$message.shift(), 6);
			if (wp.$message.length === 0) wp.$msgTimer.stop();
		}
	}

	this._delayedMsg_jamPod = function (msg, t) {
		var s = player.ship;
		//var s = this.ship; if (s.isPlayer) { n = "player" } else { n = "npc" }
		var wp = worldScripts.pods;
		if (msg) { // there is a message to output (only for player)
			wp.$scrJam.push(s); // save scr for use in callback
			wp.$msgJam.push(msg); // handle more than one message at a time //wp.$msgJam = msg; // save msg for use in callback
			if (!wp.$msgTimerJam) { // 1st message ever, set-up timer
				wp.$msgTimerJam = new Timer(wp, wp._delayedMsg_jamPod, t, t);
				if (wp.logging) log(this.name, "setup jamPod timer");
			} else {
				wp.$msgTimerJam.start();
				if (wp.logging) log(this.name, "start timer : jamPod");
			}
		} else { // timer calls itself, we have to write the message
			if (wp.logging) log(this.name, "stop timer : jamPod");
			// for pods_jamPod
			s = wp.$scrJam.shift(); // retrieve first ship (should be associated with first timer if multiple timers scheduled)
			s.setEquipmentStatus("EQ_FUEL_SCOOPS", "EQUIPMENT_DAMAGED");
			if (s.isPlayer) {
				wp.$warning_sound.play();
				player.consoleMessage(wp.$msgJam.shift(), 8);
			} else {
				s.commsMessage(wp.$msgJam.shift());
			}
			if (wp.$scrJam.length === 0) wp.$msgTimerJam.stop();
		}
	}

	this._delayedMsg_expPod = function (msg, t) {
		var s = player.ship;
		var wp = worldScripts.pods;
		if (msg) { // there is a message to output (only for player)
			wp.$scrExp.push(s);
			wp.$msgExp.push(msg);
			if (!wp.$msgTimerExp) {
				wp.$msgTimerExp = new Timer(wp, wp._delayedMsg_expPod, t, t);
				if (wp.logging) log(this.name, "setup expPod timer");
			} else {
				wp.$msgTimerExp.start();
				if (wp.logging) log(this.name, "start timer : expPod");
			}
		} else {
			if (wp.logging) log(this.name, "stop timer : expPod");
			// for pods_explodingPod
			s = wp.$scrExp.shift(); // retrieve first ship (should be associated with first timer if multiple timers scheduled)
			let damage = (Math.ceil(Math.random() * 100));
			s.energy -= damage;
			s.removeEquipment("EQ_FUEL_SCOOPS");
			if (s.isPlayer) {
				wp.$direct_hit_sound.play();
				player.consoleMessage(wp.$msgExp.shift(), 8);
			} else {
				s.commsMessage(wp.$msgExp.shift());
			}
			if (wp.$scrExp.length === 0) wp.$msgTimerExp.stop();
		}
	}

	this._delayedMsg_breachPod = function (msg, t) {
		var s = player.ship,
			n = "player";
		var wp = worldScripts.pods;
		if (msg) { // there is a message to output (only for player)
			wp.$scrBrh.push(s);
			wp.$msgBrh.push(msg); // push : addition required a parsing cut/splice/pop message ?
			if (!wp.$msgTimerBrh) {
				wp.$msgTimerBrh = new Timer(wp, wp._delayedMsg_breachPod, t, t);
				if (wp.logging) log(this.name, "setup " + n + "-timer : breachPod");
			} else {
				wp.$msgTimerBrh.start();
				if (logging) log(this.name, "start " + n + "-timer : breachPod");
			}
		} else {
			if (logging) log(this.name, "stop " + n + "-timer : breachPod");
			// for pods_breachPod
			s = wp.$scrBrh.shift(); // retrieve first ship (should be associated with first timer if multiple timers scheduled)
			if (!wp._addHullBreachRoutines(s)) return false;
			if (s.isPlayer) {
				wp.$direct_hit_sound.play();
				player.consoleMessage("ALERT - explosion in the cargo hold! Hull breach, hold content venting!", 8);
				player.consoleMessage(wp.$msgBrh.shift(), 10);
			} else {
				s.commsMessage(wp.$msgBrh.shift());
			}
			if (wp.$scrBrh.length === 0) wp.$msgTimerBrh.stop();
		}
		return true;
	}

	this._msgCargo = function (type, quantity) {
		var msg = quantity;
		if (type && quantity) {
			if (type === "gold" || type === "platinum") { // platinum / Platinum / other roles: platinumpod
				msg += " kilogram "; // gold / Gold / other roles: goldpod
			} else if (type === "gem_stones") { // gem_stones / Gem-Stones / other roles: gemstonespod
				msg += " gram ";
			} else msg += " ton ";
			if (quantity > 1) {
				msg = msg.replace("gram ", "grams "); // msg = msg.replace("ton ", "tons "); // TEST: tons
			}
			msg += displayNameForCommodity(type);
		} else {
			log(this.name, "ERROR: no var in the function this._msgCargo(type, quantity)");
		}
		return msg;
	}

	this._delayedAwrd = function (item, t, debug) { // only for player
		var wp = worldScripts.pods;
		var dg = debug;
		if (!dg) dg = wp.logging;

		if (item) { // there is an equipment to output
			wp.$equip = item;
			wp.$deqlog = dg;
			if (!wp.$eqpTimer) { // 1st item ever, set-up timer
				// new Timer(this : Object, function : Function, delay : Number [, interval : Number]) : Timer
				wp.$eqpTimer = new Timer(wp, wp._delayedAwrd, t, t);
				if (wp.logging) log(this.name, "setup generic timer");
			} else {
				wp.$eqpTimer.start();
				if (wp.logging) log(this.name, "start timer : generic");
			}
		} else { // timer calls itself, we have to write the item
			wp.$eqpTimer.stop();
			if (wp.logging) log(this.name, "stop timer : generic");
			player.ship.awardEquipment(wp.$equip); // ? wp.$warning_sound.play();
			if (wp.$deqlog) log(this.name, "awarded equipment: "+ wp.$equip);
			wp.$equip = "";
			wp.$deqlog = null;
		}
	}

	this._delayedRemoveCargo = function (ship, item, t, debug) {
		var s = ship;
		var wp = worldScripts.pods;
		var dg = debug;
		if (!dg) dg = wp.logging;

		if (item) {
			//if (dg) log(this.name, "will remove "+item.commodity+", type: "+item.$missileType+" missile, dataKey: ["+item.dataKey+"]");
			// TEST: logging for pods_missilePod

			if (dg) log(this.name, "will remove "+ item.name +", dataKey: ["+ item.dataKey +"]");

			wp.$drship = s;
			wp.$drcargo = item;
			wp.$drlog = dg;
			if (!wp.$removeCargoTimer) {
				wp.$removeCargoTimer = new Timer(wp, wp._delayedRemoveCargo, t, t);
				if (wp.logging) log(this.name, "setup removeCargo timer");
			} else {
				wp.$removeCargoTimer.start();
				if (wp.logging) log(this.name, "start timer : removeCargo");
			}
		} else {
			wp.$removeCargoTimer.stop();
			if (wp.logging) log(this.name, "stop timer : removeCargo"); // if (wp.$drship.length > 1 || wp.$drcargo.length > 1) log(this.name, "Error: length > 1");
			wp._removeCargo(wp.$drship, wp.$drcargo, wp.$drlog);
			wp.$drship = wp.$drcargo = "";
			wp.$drlog = null;
		}
	}

	this._removeCargo = function (scooper, item, debug) {
		var dg = debug;
		if (!dg) dg = this.logging;

		if (scooper && item) {
			var s;
			if (scooper.isPlayer) {
				s = "player";
			} else {
				s = "npc";
			}
			if (dg) log(this.name, "removed "+ item.name +" on the " + s + "-ship: " + scooper.name);
			
			//item.remove(true);

			var si = scooper.dumpCargo(1, item.commodity);
			if (si) {
				if (dg) log(this.name, "removed " + displayNameForCommodity(item.commodity) + "(" + item.name + ") on the " + s + "-ship: " + scooper.name);
				si.remove(true);
			} else log(this.name, "Error: not removed: " + item.name); // may be by scooper $hullBreach and etc.
		}
	}

	this._addTrumbleRoutines = function (scooper, item, type, debug) { // only for player
		var wp = worldScripts.pods;
		var scr = scooper;
		var dg = debug;
		var t = type;
		if (!dg) dg = wp.logging;
		if (!scr.isPlayer || !item || !t) return;

		var msg, an, cn, pn; // orig: msg = "Pod contains a few scraps of food, and ... Oh no! A trumble!"
		if (t === "trumble") {
			var choice = (Math.ceil(Math.random() * 4));
			if (choice == 4) { // trumble(food)
				pn = "scraps";
				cn = expandDescription('[pods_food]');
				an = "A cute alien pet.";
				if (player.trumbleCount > 0) {
					msg = "1 ton " + cn + ", and ..." // food for trumble
				}
			} else if (choice == 3) { // trumble(furs)
				pn = "piece";
				cn = expandDescription('[pods_furs]');
				an = "A cute, fluffy pet.";
			} else { // trumble
				pn = "few scraps";
				cn = 'food';
				an = "A trumble!";
			}
		} else {
			if (t === "food") pn = "few scraps"
			else if (t === "furs") pn = "few piece"
			else pn = "little part";

			an = "A trumble!";
			cn = displayNameForCommodity(t).toLowerCase();

			// delete a barrel
			wp._delayedRemoveCargo(scr, item, 0.75, dg);
		}
		if (!msg) {
			msg = "Pod contains a " + pn + " of " + cn + ", and ... Oh no! " + an;
			wp._delayedAwrd("EQ_TRUMBLE", 10, dg);
		}
		wp._delayedMsg(msg, 6);
	}

	// addition function for communicate. // not active used

	this._messageTime = clock.absoluteSeconds // for use of spacing NPC messages by ship scripts.

	this.$communicate = function (source, msgcode) // ~ this._sendMessage
	{
		if (this._messageAllowed() && source.target && source.target.isPlayer)
			source.commsMessage(expandDescription("[" + msgcode + "]"), player.ship)
		// no messages within 5 secs to avoid screen clutter.
	}

	this._messageAllowed = function () {
		if ((clock.absoluteSeconds - this._messageTime) > 5) {
			this._messageTime = clock.absoluteSeconds;
			return true;
		} else return false;
	}

	// next code is used by ship script

	this._addHullBreachRoutines = function (ship) {
		var s = ship;
		var wp = worldScripts.pods;
		var n, sc, logging = wp.logging;
		// initialise ship
		if (s && s.isPlayer) {
			n = "player";
			sc = worldScripts.pods;
		} else {
			n = "npc";
			sc = s.script;
		}
		// damage
		let damage = (Math.ceil(Math.random() * 100));
		s.energy -= damage;
		// initialise timer
		if (typeof(sc) === undefined) {
			log(this.name, "_addHullBreachRoutines encountered an undefined ship script on ship " + s);
			return false;
		} else if (!sc.$hullBreachTimer) {
			sc.$initialiseTimer = wp.$initialiseTimer;
			sc.$initialiseTimer();
		} else {
			sc.$hullBreachTimer.start();
			if (logging) log(sc.name, "start " + n + "-timer : hullBreach");
		}
		return true;
	}

	this.$initialiseTimer = function () {
		var wp = worldScripts.pods;
		var n, s, sc, logging = wp.logging;
		// initialise ship
		if (this === wp) {
			n = "player";
			s = player.ship;
			sc = worldScripts.pods;
		} else {
			n = "npc";
			s = this.ship;
			sc = s.script;
			sc.$hullBreach = wp.$hullBreach;
		}
		// initialise hullBreach timer
		sc.$hullBreachTimer = new Timer(this, sc.$hullBreach, 14, 14) // default + delay / 10 + 4
		//sc.$hullBreachTimer.stop();
		if (logging) log(sc.name, "setup " + n + "-timer : hullBreach");

	}

	this.$hullBreach = function $hullBreach() {
		var wp = worldScripts.pods;
		var n, s, logging = wp.logging;
		// initialise ship
		s = this.ship;
		if (!s) {
			n = "player";
			s = player.ship;
		} else {
			n = "npc";
		}
		var actionChance = Math.ceil(Math.random() * 5);
		switch (actionChance) {
			case 1:
				//do nothing, breach still there, but no pod lost this time.
				break;
			case 2:
				this.$hullBreachTimer.stop();
				if (logging) log(this.name, "stop " + n + "-timer : hullBreach");
				if (s.isPlayer) {
					player.consoleMessage("Hull breach repaired, alert ended.", 6)
				} else {
					s.commsMessage("Oh, repaired! Stop eject!"); // expandDescription
				}
				// end of the emergency, now just got to go hoover up the spilt pods!
				break;
			case 3:
			case 4:
			case 5:
				if (s.dumpCargo()) {
					//bye-bye pod into space! no message about loss as you'd get a screenful.
					break;
				} else { // cargo hold is empty
					this.$hullBreachTimer.stop();
					if (logging) log(this.name, "stop " + n + "-timer : hullBreach");
					if (s.isPlayer) {
						player.consoleMessage("Hull breach repaired, alert ended.", 6)
					} else {
						s.commsMessage("... no more dump!"); // expandDescription
					}
					//delete this.$hullBreachTimer;	//delete this.$hullBreach; // TEST: break cycling
					//may as well seal the breach, the hold's empty!
					break;
				}
			default:
				;
		}
	}

	this.$addMessageRoutines = function (ship, message) // NPC // not used
	{
		var wp = worldScripts.pods;
		var sc = ship.script;
		sc.$initialiseMsgTimer = wp.$initialiseMsgTimer;
		sc.$initialiseMsgTimer();
		//this.ship.script.$initialiseMsgTimer();
	}

	this._sendMessage = function (msgcode) // next code is linked to ship scripts. // ~ this.$communicate
	{
		if (worldScripts["pods"]._messageAllowed() && this.ship.target && this.ship.target.isPlayer)
			this.ship.commsMessage(expandDescription("[" + msgcode + "]"))
	}

	this._initialiseItem = function (scooper, item) // not used
	{
		if (scooper && item) {
			var s;
			if (scooper.isPlayer) {
				s = "player";
			} else {
				s = "npc";
			}
			// for pods_missilePod
			if (this.logging) log(this.name, displayNameForCommodity(item.commodity) + "(" + item.name + ") [" + item.$missileType + "] scooped by " + s + "-ship: " + scooper.name);
		} else log(this.name, "ERROR: no var in the function this._initialiseItem(scooper,item)");
	}

}).call(this);
