this.name 			= "pods_missilePod";
this.author 		= "Thargoid & Arexack Heretic & Rustem";
this.copyright 		= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description 	= "A cargo pod containing either a standard or hardened missile";

"use strict";

this.logging = false; // false for release

this.ship.$missileType = null;

this.shipSpawned = function () {
	if (!this.ship) return;
	this.ship.$missileType = (Math.random() > 0.25 ? "standard" : "hardened");
	//var si = this.ship.scriptInfo;	//var pr = this.ship.primaryRole;
	//if (si && si.missileType == "hardened") this.ship.$missileType = "hardened"
	//else if (si && si.missileType == "standard") this.ship.$missileType = "standard";
	delete this.shipSpawned;
}

this.shipWasScooped = function (scooper) {
	// initialise scooper
	var n, scr = scooper;
	if (scr.isPlayer) {
		n = "player";
	} else {
		n = "npc";
	}
	// initialise item
	var itm = this.ship;
	var dk = itm.dataKey;
	var pr = itm.primaryRole;

	var wp = worldScripts.pods;
	if (wp) {
		var cargo, msg, tc; //  "1t-cargopod"
		let type = itm.commodity;
		let quantity = parseInt(itm.commodityAmount);

		tc = "missile";
		if (!type) { // initialise RFID-broken missile: check missiles, pylon and set content (type, 1)
			// check content cargopod role

			// initialise a missile, events and messages
			if (scr.missiles.length < scr.missileCapacity) {
				itm.$missileType = this.$awardMissile(scr, itm);
				tc = itm.$missileType + " missile";
				if (this.logging) log(this.name, n + " scooped a " + tc + ", mounted to pylon");
			} else // cargo hold
			{
				if (!itm.missileType) itm.$missileType = (Math.random() > 0.25 ? "standard" : "hardened"); // reserv. string
				if (itm.setCargo("firearms")) tc = itm.$missileType + " missile";
				if (scr.isPlayer) {
					wp._delayedMsg("1 " + tc + " (Firearms)", 2);
					if (worldScripts["Cargo Scanner"] && itm.shipUniqueName) itm.shipUniqueName = itm.$missileType; // TODO: telescope indentifed, moved to _delayedMsg / _msgCargo
				}
			}
			if (this.logging) log(this.name, n + " scooped: " + tc);
		} else { // pre-set missile pod
			if (this.logging) log(this.name, "identified a pre-set " + tc + ": " + type + "[" + quantity + "] for " + n + "-scooping");

			// re-initialise a missile, events and messages
			if (type != "firearms") {
				itm.$missileType = null;
				delete this.shipDied;
			}
			if (itm.$missileType && scr.missiles.length < scr.missileCapacity) {
				itm.$missileType = this.$awardMissile(scr, itm); // adjustCargo/delete/remove for empty of the barrel?
				tc = itm.$missileType + " missile";
				wp._delayedRemoveCargo(scr, itm, 0.75);
				if (this.logging) log(this.name, n + " scooped a " + tc + ", mounted to pylon");
			} else // cargo hold
			{
				if (scr.isPlayer) {
					msg = wp._msgCargo(type, quantity); // has_scoop_message = no
					wp._delayedMsg(msg, 1); // player.consoleMessage(msg, 6);
					if (itm.$missileType && worldScripts["Cargo Scanner"] && itm.shipUniqueName) itm.shipUniqueName = itm.$missileType;
				}
				if (this.logging) log(this.name, n + " scooped a pre-set " + tc + ": " + type);
			}
		}
	}
	//delete this.shipWasScooped; // one scoop attempt
}

this.$awardMissile = function (scooper, item) {
	var wp = worldScripts.pods;
	var scr = scooper;
	var eq, mt = item.$missileType;
	if (!mt) {
		let choice = (Math.ceil(Math.random() * 4));
		if (choice == 4) {
			mt = "hardened";
		} else {
			mt = "standard";
		}
	}
	eq = (mt === "standard" ? "EQ_MISSILE" : "EQ_HARDENED_MISSILE");
	if (scr.awardEquipment(eq)) {
		if (scr.isPlayer) {
			if (wp) wp.$warning_sound.play();
			player.consoleMessage("Pylon mount: Missile class - " + mt, 6);
		}
		return mt;
	} else return "unarmed";
}

this.shipDied = function () {
	delete this.shipDied; // prefent recursion
	// TODO: Upgraded a method and tuned a value of the energy detonate in missileBarrel shipdata
	this.ship.switchAI("missileAI.plist");
	this.ship.AIState = "DETONATE";
}
