this.name 			= "pods_standardPod";
this.author 		= "Thargoid";
this.copyright 		= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description 	= "Generates message and award for alternative standard 1t pods";

this.logging = false; // false for release

this.shipWasScooped = function (scooper) {
	"use strict";
	// initialise scooper
	var n, scr = scooper;
	if (scr.isPlayer) {
		n = "player";
	} else {
		n = "npc";
	}
	// initialise item
	var itm = this.ship;
	var dk = itm.dataKey;
	var pr = itm.primaryRole;

	var wp = worldScripts.pods;
	if (wp) {
		var cargo, msg, tc; //  "1t-cargopod"
		let type = itm.commodity;
		let quantity = parseInt(itm.commodityAmount);

		tc = pr + "(standard)";
		if (!type) { // initialise RFID-broken 1t-cargopod: check scriptInfo and set content (type, quantity)
			// initialise cargo type
			type = itm.scriptInfo.podType; //quantity = 1;
			switch (type) {
				case "food":
					{
						cargo = expandDescription('[pods_food]');
						break;
					}
				case "textiles":
					{
						cargo = expandDescription('[pods_textiles]');
						break;
					}
				case "radioactives":
					{
						cargo = expandDescription('[pods_radioactives]');
						break;
					}
				case "slaves":
					{
						cargo = expandDescription('[pods_slaves]');
						break;
					}
				case "liquor_wines":
					{
						cargo = expandDescription('[pods_liquorWines]');
						break;
					}
				case "luxuries":
					{
						cargo = expandDescription('[pods_luxuries]');
						break;
					}
				case "narcotics":
					{
						cargo = expandDescription('[pods_narcotics]');
						break;
					}
				case "computers":
					{
						cargo = expandDescription('[pods_computers]');
						break;
					}
				case "machinery":
					{
						cargo = expandDescription('[pods_machinery]');
						break;
					}
				case "alloys":
					{
						cargo = expandDescription('[pods_alloys]');
						break;
					}
				case "firearms":
					{
						cargo = expandDescription('[pods_firearms]');
						break;
					}
				case "furs":
					{
						cargo = expandDescription('[pods_furs]');
						break;
					}
				case "minerals":
					{
						cargo = expandDescription('[pods_minerals]');
						break;
					}
			}
			if (!cargo || cargo === "" || !type || type === "") {
				log(this.name, "ERROR: Unable to set correct a cargo type by standard routine in the [" + dk + "]");
				return;
			}
			if (this.logging) log(this.name, "initialised a " + tc + ": " + type + "[" + quantity + "] for " + n + "-scooping");

			// set a barrel
			itm.setCargo(type, quantity); // : save a barrel // scr.manifest[type] += quantity;  // : set a new barrel for player

			// events and messages
			if (scr.isPlayer) {
				msg = "1 ton " + cargo + " (" + displayNameForCommodity(type) + ")"; // description named cargo / msg = wp._msgCargo(type,quantity); // standart named cargo
				wp._delayedMsg(msg, 2);
				// reset / broken RFID for 1t-cargopod role
				if (worldScripts["Cargo Scanner"] && itm.shipUniqueName) itm.shipUniqueName = displayNameForCommodity(type);
			}
		} else { // for pre-set 1t-cargopod
			if (this.logging) log(this.name, "identified a pre-set " + tc + ": " + type + "[" + quantity + "] for " + n + "-scooping");

			// events and messages
			if (scr.isPlayer) {
				msg = wp._msgCargo(type, quantity); // has_scoop_message = no
				player.consoleMessage(msg, 6); // wp._delayedMsg(msg, 1);
			}
		}
		if (this.logging) log(this.name, n + " scooped a standard pod: " + type);
	}
}
