this.name 			= "pods_trumblePod";
this.author 		= "Thargoid";
this.copyright 		= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description 	= "Script for a pod with a trumble in it. OK so I succumbed ;)";

this.logging = false; // false for release

this.shipWasScooped = function (scooper) {
	"use strict";
	// initialise scooper
	var n, scr = scooper;
	if (scr.isPlayer) {
		n = "player";
	} else {
		n = "npc";
	}
	// initialise item
	var itm = this.ship;
	var dk = itm.dataKey;
	var pr = itm.primaryRole;

	var wp = worldScripts.pods;
	if (wp) {
		var cargo, msg, tc; //  "1t-cargopod"
		let type = itm.commodity;
		let quantity = parseInt(itm.commodityAmount);

		tc = pr + "(trumble)";
		if (!type) { // initialise RFID-broken 1t-cargopod: check scriptInfo and set content (type, quantity)
			// set 1 food or furs in the trumble pod for NPC //quantity = 1;
			if (scr.isPlayer) {
				if (this._checkTrumble()) {
					type = "trumble";
				} else type = expandDescription('[pods_contentTons]'); // set random cargo in the cargopod for player
			} else type = (Math.random() > 0.75 ? "food" : "furs");
			if (this.logging) log(this.name, "initialised a " + tc + ": " + type + "[" + quantity + "] for " + n + "-scooping");

			// set a barrel
			itm.setCargo(type, quantity);

			// events and messages
			if (scr.isPlayer) {
				if (!this.$isTrumble) {
					msg = wp._msgCargo(type, quantity); // standart named cargo
					wp._delayedMsg(msg, 2);
					// reset / broken RFID for 1t-cargopod role
					if (worldScripts["Cargo Scanner"] && itm.shipUniqueName) itm.shipUniqueName = displayNameForCommodity(type);
				} else {
					wp._addTrumbleRoutines(scr, itm, type, this.logging);
				}
			}
		} else { // pre-set 1t-cargopod
			if (this.logging) log(this.name, "identified a pre-set " + tc + ": " + type + "[" + quantity + "] for " + n + "-scooping");

			// events and messages
			if (scr.isPlayer) {
				//msg = wp._msgCargo(type, quantity); // has_scoop_message = yes
				//player.consoleMessage(msg, 6);

				// perhaps for trumbles
				if (this._checkTrumble()) {
					wp._addTrumbleRoutines(scr, itm, type, this.logging);
				}
			}
		}
		if (this.logging) log(this.name, n + " scooped a trumble pod: " + type);
	}
}

this.$isTrumble = false;

this._checkTrumble = function () {
	if (player.trumbleCount > 0 ||
		missionVariables.trumbles === "TRUMBLE_BOUGHT" && Math.random() < 0.1 ||
		missionVariables.novacount && player.ship.equipmentStatus("EQ_TRUMBLE") === "EQUIPMENT_UNAVAILABLE") {
		this.$isTrumble = true
	}
	return this.$isTrumble
}
